//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class AxPluginSwitchOSDPos
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   04.11.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-03-11 18:05:26 +0100 (Sa, 11 Mär 2006) $
 *   $Revision: 27 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxSwitchOSDPos_H__
#define __AxSwitchOSDPos_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/plugin.h>

//----- local -----------------------------------------------------------------
#include "AxPluginSetup.h"

//=============================================================================
//     class AxPluginSwitchOSDPos
//=============================================================================
class AxPluginSwitchOSDPos : public cPlugin
{
  public:
    //-------------------------------------------------------------------------
    //     AxPluginSwitchOSDPos()
    //-------------------------------------------------------------------------
    AxPluginSwitchOSDPos(void);

    //-------------------------------------------------------------------------
    //     ~AxPluginSwitchOSDPos()
    //-------------------------------------------------------------------------
    virtual ~AxPluginSwitchOSDPos();

    //-------------------------------------------------------------------------
    //     Version()
    //-------------------------------------------------------------------------
    virtual const char *Version(void);

    //-------------------------------------------------------------------------
    //     Description()
    //-------------------------------------------------------------------------
    virtual const char *Description(void);

    //-------------------------------------------------------------------------
    //     CommandLineHelp()
    //-------------------------------------------------------------------------
    virtual const char *CommandLineHelp(void);

    //-------------------------------------------------------------------------
    //     ProcessArgs()
    //-------------------------------------------------------------------------
    virtual bool ProcessArgs(int argc, char *argv[]);

    //-------------------------------------------------------------------------
    //     Initialize()
    //-------------------------------------------------------------------------
    virtual bool Initialize(void);

    //-------------------------------------------------------------------------
    //     Start()
    //-------------------------------------------------------------------------
    virtual bool Start(void);

    //-------------------------------------------------------------------------
    //     Stop()
    //-------------------------------------------------------------------------
    virtual void Stop(void);

    //-------------------------------------------------------------------------
    //     Housekeeping()
    //-------------------------------------------------------------------------
    virtual void Housekeeping(void);

    //-------------------------------------------------------------------------
    //     MainMenuEntry()
    //-------------------------------------------------------------------------
    virtual const char *MainMenuEntry(void);

    //-------------------------------------------------------------------------
    //     MainMenuAction()
    //-------------------------------------------------------------------------
    virtual cOsdObject *MainMenuAction(void);

    //-------------------------------------------------------------------------
    //     SetupMenu()
    //-------------------------------------------------------------------------
    virtual cMenuSetupPage *SetupMenu(void);

    //-------------------------------------------------------------------------
    //     SetupParse()
    //-------------------------------------------------------------------------
    virtual bool SetupParse(const char *Name, const char *Value);

    //-------------------------------------------------------------------------
    //     Service()
    //-------------------------------------------------------------------------
    virtual bool Service(const char *Id, void *Data = NULL);

    //-------------------------------------------------------------------------
    //     SVDRPHelpPages()
    //-------------------------------------------------------------------------
    virtual const char **SVDRPHelpPages(void);

    //-------------------------------------------------------------------------
    //     SVDRPCommand()
    //-------------------------------------------------------------------------
    virtual cString SVDRPCommand(const char *Command, const char *Option, int &ReplyCode);

    //-------------------------------------------------------------------------
    //     Setup()
    //-------------------------------------------------------------------------
    AxPluginSetup &Setup() { return mySetup; }

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    char            *myMainMenuEntry;

    AxPluginSetup    mySetup;

}; // class AxPluginSwitchOSDPos


#endif

