//-----------------------------------------------------------------------------
/*
 * Description: This file contains the names & types for the service-interface
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   04.11.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-02-15 00:39:40 +0100 (Wed, 15 Feb 2006) $
 *   $Revision: 2 $
 */
//-----------------------------------------------------------------------------
#ifndef __AxSwitchOSDPosServiceTypes_H__
#define __AxSwitchOSDPosServiceTypes_H__

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
//----- vdr -------------------------------------------------------------------
#include <vdr/tools.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     Service-Names (ID)
//=============================================================================
#define SwitchOSDPos_ActivatePreset_v1_0_NAME "SwitchOSDPos-ActivatePreset-1.0"
#define SwitchOSDPos_QueryPresets_v1_0_NAME   "SwitchOSDPos-QueryPresets-1.0"


//=============================================================================
//     struct SwitchOSDPos_ActivatePreset_v1_0
//=============================================================================
/** Activates the OSD-Preset with the given name
 *
 *  like the SVDRP-command SETP
 */
struct SwitchOSDPos_ActivatePreset_v1_0
{
  /** Out: Tells the caller if the request was successful or not.
   *  Values are:
   *
   *  0 for OK
   *  1 for preset not found
   *  2 for preset is invalid (coordinates not ok)
   *
   * Set by the Service-Provider as return code
   */
  int  ErrorCode;

  /** In : Name of the Preset to activate or strlen(*Name) == 0 to query current preset
   *  Out: Name of the active preset or cString(0) if no preset active/preset not found
   *
   *  set by the Service-Caller
   */
  cString Name;

}; // struct SwitchOSDPos_ActivatePreset_v1_0

//=============================================================================
//     struct SwitchOSDPos_QueryPresets_v1_0
//=============================================================================
/** Query the names of the configured presets
 *
 *  The names of the configured presets is returned in namen where every
 *  name has a '\n' appended.
 *  For example: If there are two presets defined 'Normal' and 'Letterbox'
 *  then Names will contain "Normal\nLetterbox\n".
 *
 *  like the SVDRP-command LSTP
 */
struct SwitchOSDPos_QueryPresets_v1_0
{
  /** In : n
   *  Out: Names of the presets
   *
   *  set by the Service-Caller
   */
  cString Names;

}; // struct SwitchOSDPos_QueryPresets_v1_0

#endif

